MV           := mv -f
RM           := rm -f
SED          := sed
CC           := gcc -m32


#Compute the path relative to the common.mk, used to dup the directory structure in target directory
COMMKDIR     := $(dir $(lastword $(MAKEFILE_LIST)))
REL2COMMK    := $(subst $(realpath $(COMMKDIR)),,$(CURDIR))

sources += $(shell ls *c)

#objects      := $(subst .c,.o,$(sources))
objects      := $(subst .c,.o,$(sources))
dependencies := $(subst .c,.d,$(sources))


common_objects := $(addprefix $(COMMKDIR)common/,$(subst .c,.o,$(common_sources)))
common_dependencies := $(addprefix $(COMMKDIR)common/,$(subst .c,.d,$(common_sources)))


all_objects := $(common_objects) $(objects)
all_dependencies := $(common_dependencies) $(dependencies)


include_dirs += $(COMMKDIR)

target ?= $(objects)

all: $(target)

ifneq "$(MAKECMDGOALS)" "clean"
  -include $(dependencies)
endif


CFLAGS	+= -Wall -Werror $(addprefix -I ,$(include_dirs))


$(common_objects):
	$(MAKE) --directory=$(COMMKDIR)/common $@


%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

%.d: %.c
	$(CC) $(CFLAGS) $(TARGET_ARCH) -M $< | \
	$(SED) 's,\($*\.o\) *:,\1 $@: ,' > $@.tmp
	$(MV) $@.tmp $@

dirs = $(shell ls -d */ 2> /dev/null)

.PHONY: clean
clean::
	-for d in $(dirs); do ($(MAKE) --directory=$$d clean ); done
	$(RM) $(all_dependencies) $(all_objects) $(target)







