/* * Self-Revocation Free Downgrading - A kernel module that applies information flow
 * control to protect system integrity without self-revocation
 * Copyright (C) 2014 Secure Systems Laboratory, Stony Brook University
 *
 * This file is part of Self-Revocation Free Downgrading.
 *
 * Self-Revocation Free Downgrading is free software: you can redistribute it
 * and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Self-Revocation Free Downgrading is distributed in the hope that it will be
 * useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Self-Revocation Free Downgrading.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef __SECURITY_OPS_FINDER_H__
#define __SECURITY_OPS_FINDER_H__

/* We rely on AKARI to identify unexpected kernel structures 
   like security_operations.
*/

#include <linux/fdtable.h>
#include <linux/sched.h>

typedef void (*srfd_put_files_struct)(struct files_struct *);
typedef struct files_struct *(*srfd_get_files_struct)(struct task_struct *);


struct security_operations *ccs_find_security_ops2(void);

struct list_head *srfd_find_super_blocks(void);
srfd_put_files_struct srfd_get_put_files_struct(void);
srfd_get_files_struct srfd_get_get_files_struct(void);


#endif /* __SECURITY_OPS_FINDER_H__ */

