/* * Self-Revocation Free Downgrading - A kernel module that applies information flow
 * control to protect system integrity without self-revocation
 * Copyright (C) 2014 Secure Systems Laboratory, Stony Brook University
 *
 * This file is part of Self-Revocation Free Downgrading.
 *
 * Self-Revocation Free Downgrading is free software: you can redistribute it
 * and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Self-Revocation Free Downgrading is distributed in the hope that it will be
 * useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Self-Revocation Free Downgrading.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef __SRFD_ABSTRACT_H__
#define __SRFD_ABSTRACT_H__

#include "srfd_security.h"

int srfd_abstract_open(struct SRFD_subgroup *subgroup, struct SRFD_object *object, int mask);
//void srfd_abstract_apply_execve_creds(struct SRFD_subject *subject, struct SRFD_object *object);
int srfd_abstract_read(struct SRFD_handle *handle);
int srfd_abstract_write(struct SRFD_handle *handle);
int srfd_abstract_unlink(struct SRFD_subgroup *subgroup, struct SRFD_object *object);

#endif /* __SRFD_ABSTRACT_H__ */

