#!/usr/bin/python

# Self-Revocation Free Downgrading - A kernel module that applies information flow
# control to protect system integrity without self-revocation
# Copyright (C) 2014 Secure Systems Laboratory, Stony Brook University
#
# This file is part of Self-Revocation Free Downgrading.
#
# Self-Revocation Free Downgrading is free software: you can redistribute it
# and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Self-Revocation Free Downgrading is distributed in the hope that it will be
# useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Self-Revocation Free Downgrading.  If not, see
# <http://www.gnu.org/licenses/>.


import string
import socket
import struct
import re
import os
import shutil
import StringIO

#line = "/tmpddd/home/ubuntu/aaaaaa"

reg = r'^/home/ubuntu/\..*|\
^/home/ubuntu/test/.*|\
^/tmpddd/.*'


class PPI_nl_cmd:
	ppi_log = 0
	ppi_downgrade = 1
	ppi_temp = 2
	ppi_downgradeObject = 3


REDIRECT_DIR = "/tmp/redirect"


groups = 0

sock = socket.socket(socket.AF_NETLINK, socket.SOCK_RAW, 31)
sock.setsockopt(socket.SOL_SOCKET, socket.SO_SNDBUF, 65536)
sock.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, 6553600)

sock.bind((0, groups))
pid, groups = sock.getsockname()

_seq = 0

payload = "0AAAAAAAAAAAAAAA$\0"
length = len(payload)

hdr = struct.pack('IHHII', length + 4*4, 0, 0, _seq, pid)

sock.send(hdr + payload)
sock.send(hdr + payload)
sock.send(hdr + payload)
sock.send(hdr + payload)


f = open('log' ,'wb')
f.write("hi there\n")


while True:

	cntnts = sock.recv(4096*2)

	pktlen, pkttype, flags, seq, pid, cmd = struct.unpack('IHHIII', cntnts[:20])

	payload = cntnts[20:]

	if cmd == PPI_nl_cmd.ppi_downgradeObject:

		objectPath, newObjectLevel = struct.unpack('4096sI', cntnts[20:pktlen])

		ppifilePath = str(objectPath)
		if ppifilePath.find('\x00') >= 0:
			ppifilePath=ppifilePath[:ppifilePath.index('\x00')]

		if len(ppifilePath) == 0 or ppifilePath == "(null)":
			continue

		print repr(ppifilePath)


		print "Object " + ppifilePath + " is downgraded to level " + str(newObjectLevel)
		if (newObjectLevel) >= 5:
			continue

		matchObj = re.match(reg, payload, 0)

		if matchObj:

			if os.path.isfile(ppifilePath):
				if not os.path.exists(REDIRECT_DIR + os.path.dirname(ppifilePath)):
					os.makedirs(REDIRECT_DIR + os.path.dirname(ppifilePath))
				print "Moving file " + ppifilePath + " to " + REDIRECT_DIR + ppifilePath
				shutil.move(ppifilePath, REDIRECT_DIR + ppifilePath)
		else:
			print "Not redirectable: "+ppifilePath


#	print "cmd is " + str(cmd)

#	len, type, flags, seq, pid = struct.unpack('IHHII', cntnts[:16])
#	payload = cntnts[16:]


#	print "Payload is " 
#	print(payload)
	f.write(payload +"\n")