/* * Self-Revocation Free Downgrading - A kernel module that applies information flow
 * control to protect system integrity without self-revocation
 * Copyright (C) 2014 Secure Systems Laboratory, Stony Brook University
 *
 * This file is part of Self-Revocation Free Downgrading.
 *
 * Self-Revocation Free Downgrading is free software: you can redistribute it
 * and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Self-Revocation Free Downgrading is distributed in the hope that it will be
 * useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Self-Revocation Free Downgrading.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdlib.h>
#include <stddef.h>

char *socket_path = "hiddenLow";

int main(int argc, char *argv[]) {
	struct sockaddr_un addr;
	char buf[100], bindPath[100];
	int fd, cl, rc;
	int len;


	FILE *f = fopen("../testfiles/lowI", "r");
	if (f) {
		printf("can open lowI for reading\n");
	} else {
		printf("cannot open lowI for reading\n");
	}

	fgetc(f);

	if ( (fd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
		perror("socket error");
		exit(-1);
	}

	bzero(&addr, sizeof(addr));
	addr.sun_family = AF_UNIX;
	bindPath[0] = 0;
	len = sprintf(bindPath+1, "%s", socket_path) + 1;
	memcpy(addr.sun_path, bindPath, len);
	len += offsetof(struct sockaddr_un, sun_path);


	if (bind(fd, (struct sockaddr*)&addr, len) == -1) {
		perror("bind error");
		exit(-1);
	}

	if (listen(fd, 5) == -1) {
		perror("listen error");
		exit(-1);
	}



	while (1) {
		if ( (cl = accept(fd, NULL, NULL)) == -1) {
			perror("accept error");
			continue;
		}

		printf("sending content to peer\n");
		send(cl, "lowI content", 10, 0);

		while ( (rc=read(cl,buf,sizeof(buf))) > 0) {
			printf("read %u bytes: %.*s\n", rc, rc, buf);
		}
		if (rc == -1) {
			perror("read");
			close(cl);
		}
		else if (rc == 0) {
			printf("EOF\n");
			close(cl);
		}
	}

	fclose(f);



	return 0;
}
